# vim:set et ts=4 sts=4:
# -*- coding: utf-8 -*-
import gettext

import locale
import os
import sys
reload(sys)
sys.setdefaultencoding( "utf-8" )
import re
import webbrowser

from gi.repository import GLib
from gi.repository import Gtk
from gi.repository import IBus

from Tkinter import *

locale.setlocale(locale.LC_ALL, "")
localedir = os.getenv("IBUS_LOCALEDIR")
gettext.install('ibus-libcqsrf', localedir)
bus = IBus.Bus()
config = bus.get_config()
config_namespace = "engine/libcqsrf"

def postxx(name,val):
    var = None
    if isinstance(val, bool):
        var = GLib.Variant.new_boolean(val)
    elif isinstance(val, int):
        var = GLib.Variant.new_int32(val)
    elif isinstance(val, str):
        var = GLib.Variant.new_string(val)
    else:
        return
    config.set_value(config_namespace, name, var)

def caddczk(self):
    caddcz()
    exit()

def cquitk(self):
    cquit()
    exit()

def caddcz():
    if name in ("addcz"):
        ss="add="+addbz+"&cz="+var.get()+"&YN=2"
        chwrite(ss)
        postxx("addcz",1)
        exit()
    cs2=var.get()
    cs3=var1.get()
    mm1=var2.get()
    mm2=var3.get()
    if len(cs2)>0 and len(cs3)>10 and len(mm1)>=6 and mm1==mm2:
        ss="add=3&yhxm="+cs2+"&yhsj="+cs3+"&yhmm="+mm1+"&YN=2"
        chwrite(ss)
        postxx("cqyhgl",1)
        exit()

def cquit():
    ss="add="+addbz+"&cz="+var.get()+"&YN=0"
    chwrite(ss)
    if name in ("yhgl"):
        postxx("cqyhgl",2)
    exit()

def chwrite(text):
    fo = open(chdir+"adddelcz.txt", "w")
    fo.write(text)
    fo.close()

def chread():
    fo = open(chdir+"adddelcz.txt", "r")
    addwj=fo.read()
    fo.close()
    return re.split("&",addwj)

def getaddbz(add,na):
     for i in range(len(add)):
        aa0=re.split("=",add[i])
        if (len(aa0)==2 and aa0[0]==na):
            return aa0[1]

def get_clipboard():
    try:
        text0 = root.clipboard_get()
    except tkinter.TclError:
        text0 = ''
    if (len(text0)<2 or len(text0)>10):
        text0=''
    return text0

name = "cqsrf"
if len(sys.argv) > 1:
    name = sys.argv[1]
if name in ("szsj"):
    postxx("cqszsj",1)
    exit()
if name in ("cqweb"):
    url='http://www.znwb.com'  
    if len(sys.argv) > 2:
        url = sys.argv[2]
    webbrowser.open_new(url)
    exit()
if name not in ("addcz", "yhgl"):
    exit()
chdir=os.path.expandvars('$HOME')+"/.chenhusrf/"
cs2="0"
if len(sys.argv) > 2:
    cs2 = sys.argv[2]
cs3=""
if len(sys.argv) > 3:
    cs3 = sys.argv[3]
    if (cs3=="0"):
        cs3="";
cs4="0"
if len(sys.argv) > 4:
    cs4 = sys.argv[4]
addbz=cs2
addcz=cs3
addyn=cs4

root=Tk()
root.resizable(0,0)
root.title("智能陈桥汉字输入平台")
sw = root.winfo_screenwidth()
sh = root.winfo_screenheight()
ww=350
wh=200
if name in ("yhgl"):
    ww=500
    wh=400
x = (sw-ww) / 2
y = (sh-wh) / 2
root.geometry("%dx%d+%d+%d" %(ww,wh,x,y))
label=Label(root,text=' ',font='Helvetica -11 bold').pack()
tm='增加词组';
if name in ("addcz"):
    if (int(addbz)==2):
        tm='删除词组'
    if (int(addbz)!=2) and len(addbz)<2:
        addcz=get_clipboard()
if name in ("yhgl"):
    tm='输入用户信息'
label=Label(root,text=tm,font='Helvetica -20 bold').pack()
label=Label(root,text=' ',font='Helvetica -11 bold').pack()

fm0 = Frame(root)
fm0.pack(side=TOP, fill=BOTH, expand=YES)
tm='请输入词组：';
if name in ("yhgl"):
    tm='姓名或编号：'
if name in ("yhgl","addcz"):
    label=Label(fm0,text=tm,font='Helvetica -16 bold').pack(side=LEFT, expand=YES)
    var=StringVar()
    Entry(fm0,textvariable=var,font='Helvetica -16 bold').pack(side=RIGHT, expand=YES)
    var.set(addcz)
if name in ("yhgl"):
    var.set(cs2)
    fm2 = Frame(root)
    fm2.pack(side=TOP, fill=BOTH, expand=YES)
    tm='手机号码：';
    label=Label(fm2,text=tm,font='Helvetica -16 bold').pack(side=LEFT, expand=YES)
    var1=StringVar()
    Entry(fm2,textvariable=var1,font='Helvetica -16 bold').pack(side=RIGHT, expand=YES)
    var1.set(cs3)
    fm3 = Frame(root)
    fm3.pack(side=TOP, fill=BOTH, expand=YES)
    tm='输入第一次密码：';
    label=Label(fm3,text=tm,font='Helvetica -16 bold').pack(side=LEFT, expand=YES)
    var2=StringVar()
    Entry(fm3,textvariable=var2,font='Helvetica -16 bold').pack(side=RIGHT, expand=YES)
    fm4 = Frame(root)
    fm4.pack(side=TOP, fill=BOTH, expand=YES)
    tm='再输入一次密码：';
    label=Label(fm4,text=tm,font='Helvetica -16 bold').pack(side=LEFT, expand=YES)
    var3=StringVar()
    Entry(fm4,textvariable=var3,font='Helvetica -16 bold').pack(side=RIGHT, expand=YES)
    tm='注意：密码为六位，两次密码必须一样，否则不能通过确认！';
    label=Label(root,text=tm,font='Helvetica -16 bold').pack(side=TOP, expand=YES)

fm1 = Frame(root)
fm1.pack(side=BOTTOM, fill=BOTH, expand=YES)
b1=Button(fm1,text="确 定",command=caddcz,font='Helvetica -16 bold')
b1.pack(side=RIGHT, expand=YES)
b2=Button(fm1,text="放 弃",command=cquit,font='Helvetica -16 bold')
b2.pack(side=RIGHT, expand=YES)
b1.bind_all("<Escape>", cquitk)
b1.bind_all('<Return>', caddczk)
root.mainloop()

